'use strict';
var Alexa = require('alexa-sdk');
var APP_ID = undefined;
var languageStrings = {
    "en-US": {
        "translation": {
            "FACTS": [
                "Ptolemy III, the king of Egypt, offered to pay for the Colossus of Rhodes reconstruction. The Rhodians refused. They believed that Helios himself was angered by the statue and caused the earthquake that destroyed it.",
		"If we tried to build an exact replica of the great pyramid of Giza it would not be possible. We do not have the precise technology that the ancient Egyptians had that was necessary to build this pyramid.",
		"The Hanging Gardens of Babylon are the only one of the Seven Wonders of the ancient world that may not even have existed.",
		"Today the city of Alexandria uses the symbol of the lighthouse on the flag of the Alexandria Governorate as well as on their seal.",
		"Most of the mausoleum at Halicarnassus was made of marble. It was surrounded by a courtyard.",
		"The statue of Zeus at Olympia was portrayed according to Book One, verses 528 – 530, of Homer's Iliad.",
		"The temple of artemis had to be rebuilt at least three times due to fire, flood, and a mob that was determined to destroy it. Each time it was rebuilt it became larger and even more beautiful and impressive."
            ],
            "SKILL_NAME" : "World Wonders Facts",
            "GET_FACT_MESSAGE" : "Here's your fact: ",
            "HELP_MESSAGE" : "You can say tell me a fact, or, you can say exit... What can I help you with?",
            "HELP_REPROMPT" : "What can I help you with?",
            "STOP_MESSAGE" : "Goodbye!"
        }
    }
};

var handlers = {
    'LaunchRequest': function () {
        this.emit('GetFact');
    },
    'GetNewFactIntent': function () {
        this.emit('GetFact');
    },
    'GetFact': function () {
        var factArr = this.t('FACTS');
        var factIndex = Math.floor(Math.random() * factArr.length);
        var randomFact = factArr[factIndex];
        var speechOutput = this.t("GET_FACT_MESSAGE") + randomFact;
        this.emit(':tell', speechOutput);
    },
    'AMAZON.HelpIntent': function () {
        var speechOutput = this.t("HELP_MESSAGE");
        var reprompt = this.t("HELP_MESSAGE");
        this.emit(':ask', speechOutput, reprompt);
    },
    'AMAZON.CancelIntent': function () {
        this.emit(':tell', this.t("STOP_MESSAGE"));
    },
    'AMAZON.StopIntent': function () {
        this.emit(':tell', this.t("STOP_MESSAGE"));
    }
};

exports.handler = function(event, context, callback) {
    var alexa = Alexa.handler(event, context);
    alexa.APP_ID = APP_ID;
    alexa.resources = languageStrings;
    alexa.registerHandlers(handlers);
    alexa.execute();
};