'use strict';
var Alexa = require('alexa-sdk');
var APP_ID = undefined; // TODO replace with your app ID (OPTIONAL).

var ancientwonders = require('./wonders');
var newwonders =require('./wonders');
var output = "";

var languageStrings = {
    "en-US": {
        "translation": {
            "ANCIENT_WONDERS" : ancientwonders.ANCIENTWONDERS_EN_US,
			"NEW_WONDERS" : newwonders.NEWWONDERS_EN_US,
            "SKILL_NAME" : "World Wonders Custom Slots",
            "WELCOME_MESSAGE": "Welcome to %s. You can ask a question like, Do you know something about the great wall? ... Now, what can I help you with.",
            "WELCOME_REPROMT": "For instructions on what you can say help, or you can say exit if you wish to leave.",
			"HELP_MESSAGE": [
				"You can ask questions such as, Do you know something about machu pichu, or, you can say exit...Now, what can I help you with?",,
                "If you want to know the wonders say New or Ancient",
				"Try to say Give me a fact about the Colossus",
				"This app includes all 7 ancient and new world wonders"
            ],
			"HELP_REPROMT": "You can say things like, Do you know something about the lighthouse, or you can say exit...Now, what can I help you with?",
            "STOP_MESSAGE": "Thanks for your time, Goodbye!",
            "WONDERS_REPEAT_MESSAGE": "Try saying repeat.",
            "WONDERS_NOT_FOUND_MESSAGE": "I'm sorry,",
			"WONDERS_NOT_FOUND_REPROMPT": "What else can I help with?",
            "WONDERS_FOUND_WITH_NO_INFO": " I do not know anything about %s. ",
            "WONDERS_NOT_FOUND": " I did not found the wonder, say do you know an ancient wonder to hear a list"
        }
    }
};

var handlers = {
    'LaunchRequest': function () {
        this.attributes['speechOutput'] = this.t("WELCOME_MESSAGE", this.t("SKILL_NAME"));
        this.attributes['repromptSpeech'] = this.t("WELCOME_REPROMT");
		output=this.attributes['speechOutput'];
        this.emit(':ask', output, this.attributes['repromptSpeech']);
    },
    'GetAncientFactIntent': function () {
        var WWSlot = this.event.request.intent.slots.ANCIENTWONDER;
        var WWName;
        if (WWSlot && WWSlot.value) {
            WWName = WWSlot.value.toLowerCase();
        }
        var ancientwonders = this.t("ANCIENT_WONDERS");
		var AuxArr = ancientwonders[WWName];
        var Index = Math.floor(Math.random() * AuxArr.length);
        output = AuxArr[Index];
		
        if (output) {
            this.attributes['speechOutput'] = output;
            this.attributes['repromptSpeech'] = this.t("WONDERS_REPEAT_MESSAGE");
			this.emit(':ask', output, this.attributes['repromptSpeech']);
        } else {
            var speechOutput = this.t("WONDERS_NOT_FOUND_MESSAGE");
            var repromptSpeech = this.t("WONDERS_NOT_FOUND_REPROMPT");
            if (WWName) {
                speechOutput += this.t("WONDERS_FOUND_WITH_NO_INFO", WWName);
            } else {
                speechOutput += this.t("WONDERS_NOT_FOUND");
            }
            speechOutput += repromptSpeech;
			
            this.attributes['speechOutput'] = speechOutput;
            this.attributes['repromptSpeech'] = repromptSpeech;
			output=speechOutput;
            this.emit(':ask', output, repromptSpeech);
        }
    },
	'GetNewFactIntent': function () {
        var WWSlot = this.event.request.intent.slots.NEWWONDER;
        var WWName;
        if (WWSlot && WWSlot.value) {
            WWName = WWSlot.value.toLowerCase();
        }
        var newwonders = this.t("NEW_WONDERS");
		var AuxArr = newwonders[WWName];
        var Index = Math.floor(Math.random() * AuxArr.length);
        output = AuxArr[Index];
		
		
        if (output) {
            this.attributes['speechOutput'] = output;
            this.attributes['repromptSpeech'] = this.t("WONDERS_REPEAT_MESSAGE");
            this.emit(':ask', output, this.attributes['repromptSpeech']);
        } else {
            var speechOutput = this.t("WONDERS_NOT_FOUND_MESSAGE");
            var repromptSpeech = this.t("WONDERS_NOT_FOUND_REPROMPT");
            if (WWName) {
                speechOutput += this.t("WONDERS_FOUND_WITH_NO_INFO", WWName);
            } else {
                speechOutput += this.t("WONDERS_NOT_FOUND");
            }
            speechOutput += repromptSpeech;
			
            this.attributes['speechOutput'] = speechOutput;
            this.attributes['repromptSpeech'] = repromptSpeech;
			output=speechOutput;
            this.emit(':ask', output, repromptSpeech);
        }
    },
	'AMAZON.HelpIntent': function () {
		var AuxArr = this.t('HELP_MESSAGE');
        var Index = Math.floor(Math.random() * AuxArr.length);
        var HelpMessage = AuxArr[Index];
		output=HelpMessage;
        this.emit(':ask', output, output);
    },
	'AMAZON.RepeatIntent': function () {
		var AuxArr = this.t('HELP_MESSAGE');
        var Index = Math.floor(Math.random() * AuxArr.length);
        var HelpMessage = AuxArr[Index];
        this.emit(':ask', output, HelpMessage);
    },
	
    'AMAZON.StopIntent': function () {
        this.emit('SessionEndedRequest');
    },
    'AMAZON.CancelIntent': function () {
        this.emit('SessionEndedRequest');
    }
};


exports.handler = function(event, context, callback) {
    var alexa = Alexa.handler(event, context);
    alexa.APP_ID = APP_ID;
    alexa.resources = languageStrings;
    alexa.registerHandlers(handlers);
    alexa.execute();
};