'use strict';

const Alexa = require('alexa-sdk');
 
//Cambiar el id de la aplicación por el propio de esta manera:  var APP_ID = "amzn1.ask.skill.bb4045e6-b3e8-4133-b650-72923c7980f1";
var APP_ID = undefined;

//Esta función regresa una oración descriptiva de los datos al preguntar por informacion.
function getSpeechDescription(item)
{
    var sentence = item.WonderName + " is located in  " + item.Location + ", the principal function of this wonder was the one of " + item.Functionality + ".  The wonder " + item.WonderName + " was made of " + item.MadeOf + ", and one interesting fact is that " + item.Fact + ".  I've added " + item.WonderName + " to your Alexa app.  Which other ancient world wonder would you like to know about?";
    return sentence;
}

//Estructura para hacer las preguntas dependiendo de la información solicitada
function getQuestion(counter, QuestionAnswer, DataForQuestion, item)
{
    switch(DataForQuestion)
    {
        case "Location":
            return "Here is your " + counter + "th question.  What is the wonder that is located on " + item[DataForQuestion] + "?";
        break;
        case "Functionality":
            return "Here is your " + counter + "th question.  What is the wonder that was used as a " + item[DataForQuestion] + "?";
        break;
        case "MadeOf":
            return "Here is your " + counter + "th question.  What is the wonder that was made of " + item[DataForQuestion] + "?";
        break;
        case "Fact":
            return "Here is your " + counter + "th question.  Which is the wonder that correspond to this fact? " + item[DataForQuestion];
        break;
        default:
            return "Sorry, I do not what to ask for " +item[DataForQuestion]+ " as your " + counter + "th question.";
        break;
    }
}

//Estructura para hacer la respuesta dependiendo de la información solicitada
function getAnswer(QuestionAnswer, DataForQuestion, item)
{
    switch(DataForQuestion)
    {
        case "Location":
            return item[DataForQuestion] +" is the Location of " + item[QuestionAnswer] + ". ";
        break;
        case "Functionality":
            return item[DataForQuestion] +" is what " + item[QuestionAnswer] + " was used for. ";
        break;
        case "MadeOf":
            return item[DataForQuestion] +" was used to make " + item[QuestionAnswer] + ". ";
        break;
        case "Fact":
            return item[DataForQuestion] +" is a Fact of " + item[QuestionAnswer] + ". ";
        break;
        default:
            return item[DataForQuestion]  +" is the answer of " + item[QuestionAnswer] + ". ";
        break;
    }
}

//Expresiones Positivas
var speechConsCorrect = ["Booya", "All righty", "Bam", "Bazinga", "Bingo", "Boom", "Bravo", "Cha Ching", "Cheers", "Dynomite", 
"Hip hip hooray", "Hurrah", "Hurray", "Huzzah", "Oh dear.  Just kidding.  Hurray", "Kaboom", "Kaching", "Oh snap", "Phew", 
"Righto", "Way to go", "Well done", "Whee", "Woo hoo", "Yay", "Wowza", "Yowsa"];

//Expresiones Negativas
var speechConsWrong = ["Argh", "Aw man", "Blarg", "Blast", "Boo", "Bummer", "Darn", "D'oh", "Dun dun dun", "Eek", "Honk", "Le sigh",
"Mamma mia", "Oh boy", "Oh dear", "Oof", "Ouch", "Ruh roh", "Shucks", "Uh oh", "Wah wah", "Whoops a daisy", "Yikes"];

//Mensaje de bienvenida
var WELCOME_MESSAGE = "Welcome to the World Wonders Quiz Game!  You can ask me about any of the seven wonders and their info, or you can ask me to start a quiz.  What would you like to do?";  

//Mensaje de inicio de quiz
var START_QUIZ_MESSAGE = "OK.  I will ask you 10 questions about the world wonders.";

//Mensaje de salida
var EXIT_SKILL_MESSAGE = "Thank you for playing the World wonders Quiz Game!  Let's play again soon!";

//Mensaje por si no se obtiene respuesta en cierto tiempo
var REPROMPT_SPEECH = "Which other wonder would you like to know about?";

//Mensaje de ayuda
var HELP_MESSAGE = "I know lots of things about the World Wonders.  You can ask me about a wonder, and I'll tell you what I know.  You can also test your knowledge by asking me to start a quiz.  What would you like to do?";


//Mensaje de error (no existe información sobre eso)
function getBadAnswer(item) { return "I'm sorry. " + item + " is not something I know very much about in this skill. " + HELP_MESSAGE; }

//Mensaje de puntaje actual
function getCurrentScore(score, counter) { return "Your current score is " + score + " out of " + counter + ". "; }

//Mensaje de puntaje final
function getFinalScore(score, counter) { return "Your final score is " + score + " out of " + counter + ". "; }

//INFORMACION para el quiz
var data = [
                {WonderName: "Ancient Colossus",    Location: "Rhodes",         Functionality: "Commemoration of War Victory",            MadeOf: "Bronze plates attached to iron framework",                 Fact: "Made in the shape of the island's patron god Helios" },
                {WonderName: "Great Pyramid",       Location: "Giza",           Functionality: "Tomb of Pharaoh",              MadeOf: "Mostly limestone",                                         Fact: "The oldest of all Seven Wonders of the World" },
                {WonderName: "Hanging Gardens",     Location: "Babylon",        Functionality: "Royal Garden",                      MadeOf: "Mud brick waterproofed with lead",                         Fact: "The only one of the Seven Wonders of the ancient world that may not even have existed" },
                {WonderName: "Lighthouse",          Location: "Alexandria",     Functionality: "Guidance of Ships", MadeOf: "Stone faced with white marble blocks with lead mortar",    Fact: "Said to be the only ancient wonder with a practical application" },
                {WonderName: "Mausoleum",           Location: "Halicarnassus",  Functionality: "Tomb for the City King",   MadeOf: "White Marble",                                             Fact: "There were scenes of Greek and Amazon warriors and their battles on their walls" },
                {WonderName: "Statue of Zeus",      Location: "Olympia",        Functionality: "Shine to a Greek God",            MadeOf: "Ivory and gold-plated plates on wooden frame",             Fact: "It was created by Phidias, it took him 12 years" },
                {WonderName: "Temple of Artemis",   Location: "Ephesus",        Functionality: "Temple to a Goddess",          MadeOf: "Mostly marble",                                            Fact: "It had to be rebuild at least three times due to fire, each time becoming larger and beautiful than before" }
            ];

//Editar cualquier cosa abajo puede hacer que la habilidad no funcione correctamente
//Investigar y comprender las funciones antes de hacer cualquier cambio abajo
var counter = 0;

var states = {
    START: "_START",
    QUIZ: "_QUIZ"
};

const handlers = {
     "LaunchRequest": function() {
        this.handler.state = states.START;
        this.emitWithState("Start");
     },
    "QuizIntent": function() {
        this.handler.state = states.QUIZ;
        this.emitWithState("Quiz");
    },
    "AnswerIntent": function() {
        this.handler.state = states.START;
        this.emitWithState("AnswerIntent");
    },
    "AMAZON.HelpIntent": function() {
        this.emit(":ask", HELP_MESSAGE, HELP_MESSAGE);
    },
    "Unhandled": function() {
        this.handler.state = states.START;
        this.emitWithState("Start");
    }
};

var startHandlers = Alexa.CreateStateHandler(states.START,{
    "Start": function() {
        this.emit(":ask", WELCOME_MESSAGE, HELP_MESSAGE);
    },
    "AnswerIntent": function() {
        var item = getItem(this.event.request.intent.slots);

        if (item[Object.getOwnPropertyNames(data[0])[0]] != undefined)
        {
            this.emit(":ask", getSpeechDescription(item), REPROMPT_SPEECH);
        }
        else
        {
            this.emit(":ask", getBadAnswer(item), getBadAnswer(item));
        }
    },
    "QuizIntent": function() {
        this.handler.state = states.QUIZ;
        this.emitWithState("Quiz");
    },
    "AMAZON.StopIntent": function() {
        this.emit(":tell", EXIT_SKILL_MESSAGE);
    },
    "AMAZON.CancelIntent": function() {
        this.emit(":tell", EXIT_SKILL_MESSAGE);
    },
    "AMAZON.HelpIntent": function() {
        this.emit(":ask", HELP_MESSAGE, HELP_MESSAGE);
    },
    "Unhandled": function() {
        this.emitWithState("Start");
    }
});


var quizHandlers = Alexa.CreateStateHandler(states.QUIZ,{
    "Quiz": function() {
        this.attributes["response"] = "";
        this.attributes["counter"] = 0;
        this.attributes["quizscore"] = 0;
        this.emitWithState("AskQuestion");
    },
    "AskQuestion": function() {
        if (this.attributes["counter"] == 0)
        {
            this.attributes["response"] = START_QUIZ_MESSAGE + " ";
        }

        var random = getRandom(0, data.length-1);
        var item = data[random];

        var propertyArray = Object.getOwnPropertyNames(item);
        var QuestionAnswer = propertyArray[0];
        var DataForQuestion = propertyArray[getRandom(1, propertyArray.length-1)];

        this.attributes["quizitem"] = item;
        this.attributes["quizanswer"] = QuestionAnswer;
        this.attributes["quizdataforquestion"] = DataForQuestion;
        this.attributes["counter"]++;

        var question = getQuestion(this.attributes["counter"], QuestionAnswer, DataForQuestion, item);
        var speech = this.attributes["response"] + question;

        this.emit(":ask", speech, question);
    },
    "AnswerIntent": function() {
        var response = "";
        var item = this.attributes["quizitem"];
        var QuestionAnswer = this.attributes["quizanswer"]
        var DataForQuestion = this.attributes["quizdataforquestion"]

        var correct = compareSlots(this.event.request.intent.slots, item[QuestionAnswer]);

        if (correct)
        {
            response = getSpeechCon(true);
            this.attributes["quizscore"]++;
        }
        else
        {
            response = getSpeechCon(false);
        }

        response += getAnswer(QuestionAnswer,DataForQuestion, item);

        if (this.attributes["counter"] < 10)
        {
            response += getCurrentScore(this.attributes["quizscore"], this.attributes["counter"]);
            this.attributes["response"] = response;
            this.emitWithState("AskQuestion");
        }
        else
        {
            response += getFinalScore(this.attributes["quizscore"], this.attributes["counter"]);
            this.emit(":tell", response + " " + EXIT_SKILL_MESSAGE);
        }
    },
    "AMAZON.StartOverIntent": function() {
        this.emitWithState("Quiz");
    },
    "AMAZON.StopIntent": function() {
        this.emit(":tell", EXIT_SKILL_MESSAGE);
    },
    "AMAZON.CancelIntent": function() {
        this.emit(":tell", EXIT_SKILL_MESSAGE);
    },
    "AMAZON.HelpIntent": function() {
        this.emit(":ask", HELP_MESSAGE, HELP_MESSAGE);
    },
    "Unhandled": function() {
        this.emitWithState("AnswerIntent");
    }
});

function compareSlots(slots, value)
{
    for (var slot in slots)
    {
        if (slots[slot].value != undefined)
        {
            if (slots[slot].value.toString().toLowerCase() == value.toString().toLowerCase())
            {
                return true;
            }
        }
    }
    return false;
}

function getRandom(min, max)
{
    return Math.floor(Math.random() * (max-min+1)+min);
}

function getRandomSymbolSpeech(symbol)
{
    return "<say-as interpret-as='spell-out'>" + symbol + "</say-as>";
}

function getItem(slots)
{
    var propertyArray = Object.getOwnPropertyNames(data[0]);
    var value;
    
    for (var slot in slots)
    {
        if (slots[slot].value !== undefined)
        {
            value = slots[slot].value;
            for (var QuestionAnswer in propertyArray)
            {
                var item = data.filter(x => x[propertyArray[QuestionAnswer]].toString().toLowerCase() === slots[slot].value.toString().toLowerCase());
                if (item.length > 0)
                {
                    return item[0];
                }
            }
        }
    }
    return value;
}

function getSpeechCon(type)
{
    var speechCon = "";
    if (type) return "<say-as interpret-as='interjection'>" + speechConsCorrect[getRandom(0, speechConsCorrect.length-1)] + "! </say-as><break strength='strong'/>";
    else return "<say-as interpret-as='interjection'>" + speechConsWrong[getRandom(0, speechConsWrong.length-1)] + " </say-as><break strength='strong'/>";    
}

function formatCasing(key)
{
    key = key.split(/(?=[A-Z])/).join(" ");
    return key;
}

function getTextDescription(item)
{
    var text = "";
    
    for (var key in item)
    {
        text += formatCasing(key) + ": " + item[key] + "\n";
    }
    return text;
}

exports.handler = (event, context) => {
    const alexa = Alexa.handler(event, context);
    alexa.appId = APP_ID;
    alexa.registerHandlers(handlers, startHandlers, quizHandlers);
    alexa.execute();
};